# Source Generated with Decompyle++
# File: in.pyc (Python 2.7)

from quodlibet.player._base import BasePlayer
from quodlibet.player import PlayerError

class NullPlayer(BasePlayer):
    __gproperties__ = BasePlayer._gproperties_
    __gsignals__ = BasePlayer._gsignals_
    version_info = 'Null Player Backend'
    name = 'Null'
    
    def __init__(self, sinkname = '', librarian = None):
        super(NullPlayer, self).__init__()
        self._set_paused(True)
        self._source = None
        self._position = 0

    
    def _destroy(self):
        pass

    
    def get_position(self):
        '''Return the current playback position in milliseconds,
        or 0 if no song is playing.'''
        return self._position

    
    def _set_paused(self, paused):
        if paused != self._paused:
            self._paused = paused
            if self.song:
                if not paused or 'paused':
                    pass
                self.emit('unpaused')
            elif paused is True:
                self.emit('paused')
            

    
    def _get_paused(self):
        return self._paused

    paused = property(_get_paused, _set_paused)
    
    def do_set_property(self, property, v):
        if property.name == 'volume':
            self._volume = v
        else:
            raise AttributeError

    
    def _error(self, message):
        self.paused = True
        self.emit('error', self.song, PlayerError(message))

    
    def seek(self, pos):
        '''Seek to a position in the song, in milliseconds.'''
        if self.song:
            self.emit('seek', self.song, pos)
        self._position = pos

    
    def _end(self, stopped, next_song = None):
        song = self.song
        self.song = None
        self.info = None
        self.emit('song-ended', song, stopped)
        current = self._source.current if next_song is None else next_song
        self.song = self.info = current
        self.emit('song-started', self.song)
        if self.song is None:
            self.paused = True
        if not (self.paused) and song is None:
            self.emit('unpaused')
        self._position = 0

    
    def can_play_uri(self, uri):
        return False



def init(librarian):
    return NullPlayer(librarian)

